import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.nio.DoubleBuffer;

import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLCanvas;
import javax.media.opengl.GLEventListener;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.sun.opengl.util.GLUT;

public class Trabalho extends Applet implements GLEventListener, KeyListener {

	private static final long serialVersionUID = 1L;
	private static GLAutoDrawable glDraw;

	private static JRadioButton ortogonal;
	private static JRadioButton obliqua;
	private static JRadioButton axonometrica;
	private static JRadioButton perspectiva;

	private static JRadioButton teta;
	private static JRadioButton fi;

	private static GLCanvas canvas;
	private static double xMax = 700D / 2D;
	private static double viewportX = 700D;
	private static double viewportY = 500D;
	private static double yMax = 500D / 2D;
	private static double aspect = 700 / 500.0;
	private static double X = 350D;
	private static double Y = 250D;

	private static double Alfa = 35;
	private static double l = 0.5;

	private static double pfi = Math.toDegrees(Math.asin(Math.sqrt(Math
			.tan(Math.toRadians(42))
			* Math.tan(Math.toRadians(7)))));
	private static double pteta = Math.toDegrees(Math.atan(Math.sqrt(Math
			.tan(Math.toRadians(42))
			/ Math.tan(Math.toRadians(7))))
			- Math.PI / 2.0);

	private static double D = 500;
	
	
	
	public static void main(String[] a) {
		JFrame frame = new JFrame("Arvorezinha");
		canvas = new GLCanvas();

		Trabalho t = new Trabalho();
		canvas.addGLEventListener(t);
		canvas.addKeyListener(t);
		canvas.setSize(700, 500);

		frame.add(canvas, BorderLayout.CENTER);
		JPanel painelControlo = criarPainelControlo();
		//JPanel painelDados = criarPainelDados();
		frame.add(painelControlo, BorderLayout.EAST);
		//frame.add(painelDados, BorderLayout.SOUTH);
		frame.pack();
		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		canvas.requestFocusInWindow();
		frame.setVisible(true);

	}

	private static JPanel criarPainelDados() {
		teta = new JRadioButton("teta");
		teta.setSelected(true);
		// teta.addChangeListener(new ChangeListener() {
		// @Override
		// public void stateChanged(ChangeEvent e) {
		// glDraw.display();
		// }
		//
		// });

		fi = new JRadioButton("fi");
		fi.setSelected(true);
		// fi.addChangeListener(new ChangeListener() {
		// @Override
		// public void stateChanged(ChangeEvent e) {
		// glDraw.display();
		// }
		//
		// });

		ButtonGroup grupo = new ButtonGroup();
		grupo.add(teta);
		grupo.add(fi);

		JPanel painel = new JPanel();
		painel.setLayout(new BoxLayout(painel, 1));
		painel.add(teta);
		painel.add(fi);
		return painel;
	}

	public static double convx(int x) {
		return (double) x * (xMax * 2) / viewportX - xMax;
	}

	public static double convy(int y) {
		return (double) y * (yMax * 2) / viewportY - yMax;
	}

	private static JPanel criarPainelControlo() {
		JPanel painelCurvas = criarRadioButtons();
		JPanel painelBotoes = criarPainelDados();
		//JPanel painelMostrar = criarCheckBoxes();
		JPanel painel = new JPanel();
		painel.setLayout(new GridLayout(3, 1));
		painel.add(painelCurvas);
		//painel.add(painelMostrar);
		painel.add(painelBotoes);

		return painel;
	}



	public static JPanel criarRadioButtons() {

		perspectiva = new JRadioButton("Perspectiva");
		obliqua = new JRadioButton("Obliqua");
		ortogonal = new JRadioButton("Ortogonal");
		axonometrica = new JRadioButton("Axonometrica", true);

		ButtonGroup grupo = new ButtonGroup();
		grupo.add(perspectiva);
		grupo.add(obliqua);
		grupo.add(ortogonal);
		grupo.add(axonometrica);

		class state implements ChangeListener {

			@Override
			public void stateChanged(ChangeEvent e) {
				if (ortogonal.isSelected()) {
					fi.setVisible(false);
					teta.setVisible(false);
				} else if (axonometrica.isSelected()) {
					fi.setVisible(true);
					teta.setVisible(true);
					teta.setLabel("Teta");
					fi.setLabel("Fi");
				} else if (obliqua.isSelected()) {
					teta.setLabel("L");
					fi.setLabel("Alfa");
					fi.setVisible(true);
					teta.setVisible(true);
				} else if (perspectiva.isSelected()) {
					fi.setVisible(false);
					teta.setVisible(false);
				}
				glDraw.display();

			}
		}
		axonometrica.addChangeListener(new state());
		obliqua.addChangeListener(new state());
		ortogonal.addChangeListener(new state());
		perspectiva.addChangeListener(new state());

		JPanel painel = new JPanel();
		painel.setLayout(new BoxLayout(painel, 1));
		painel.add(axonometrica);
		painel.add(obliqua);
		painel.add(ortogonal);
		painel.add(perspectiva);

		// painel.add(pontos);
		painel.setBorder(new TitledBorder(new EtchedBorder(), "Projeccoes"));
		return painel;
	}

	@Override
	public void display(GLAutoDrawable gLDrawable) {
		GL gl = gLDrawable.getGL();
		

		gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
		// gl.glClear(GL.GL_COLOR_BUFFER_BIT);
		gl.glMatrixMode(GL.GL_MODELVIEW);
		gl.glLoadIdentity();
		getProjection(gl);

		gl.glBegin(GL.GL_LINES);
		gl.glColor3d(1, 1, 1);
		for (int i = -300; i <= 300; i += 50) {
			gl.glVertex3d(i, 0, -300);
			gl.glVertex3d(i, 0, 300);

			gl.glVertex3d(-300, 0, i);
			gl.glVertex3d(300, 0, i);
		}
		gl.glEnd();

		GLUT glut = new GLUT();

		gl.glColor3d(92 / 255.0, 51 / 255.0, 23 / 255.0);
		gl.glRotated(-90, 1, 0, 0);
		gl.glPushMatrix();
		glut.glutSolidCylinder(50, 70, 100, 100);
		gl.glPopMatrix();

		gl.glTranslated(0, 0, 70);

		gl.glColor3d(34 / 255.0, 139 / 255.0, 34 / 255.0);
		glut.glutSolidCone(100, 200, 100, 100);

	}


	private void getProjection(GL gl) {
		DoubleBuffer aux = DoubleBuffer.allocate(16);

		for (int i = 0; i < aux.capacity(); i++) {
			aux.put(i, 0);
		}

		if (obliqua.isSelected()) {
			aux.put(0, 1);

			aux.put(5, 1);

			aux.put(8, -l * Math.cos(Math.toRadians(Alfa)));
			aux.put(9, -l * Math.sin(Math.toRadians(Alfa)));
			aux.put(10, 1);
			aux.put(15, 1);
		} else if (ortogonal.isSelected() || axonometrica.isSelected()) {
			aux.put(0, 1);

			aux.put(5, 1);
			aux.put(10, 1);
			aux.put(15, 1);
		} else if (perspectiva.isSelected()) {
			aux.put(0, 1);

			aux.put(5, 1);

			aux.put(10, 1);
			aux.put(11, -1 / D);

			aux.put(15, 1);
		}

		gl.glMatrixMode(GL.GL_PROJECTION);
		gl.glLoadIdentity();
		gl.glOrtho(-xMax * 2, xMax * 2, -yMax * 2, yMax * 2, -700, 700);
		gl.glMultMatrixd(aux);
		if (axonometrica.isSelected()) {
			gl.glRotated(pfi, 1.0, 0, 0);
			gl.glRotated(pteta, 0.0, 1.0, 0);
		}
	}

	@Override
	public void displayChanged(GLAutoDrawable gLDrawable, boolean modeChanged,
			boolean deviceChanged) {
	}

	@Override
	public void init(GLAutoDrawable gLDrawable) {
		glDraw = gLDrawable;
		GL gl = gLDrawable.getGL();
		gl = gLDrawable.getGL();
		// gl.glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
		gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
		gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
		// gl.glClearColor(102/255f, 102/255f, 102/255f, 102/255f);

		gl.glEnable(GL.GL_DEPTH_TEST);
		gl.glShadeModel(GL.GL_FLAT);

		gl.glEnable(GL.GL_MAP2_VERTEX_3);
		gl.glMapGrid2d(20, 0, 1, 20, 0, 1);
	}

	public void reshape(GLAutoDrawable gLDrawable, int x, int y, int width,
			int height) {
		GL gl = gLDrawable.getGL();
		// GLU glu = new GLU();

		// gl.glViewport(0, 0, width, height);
		// gl.glMatrixMode(GL.GL_PROJECTION);
		// gl.glLoadIdentity();
		// if (width <= height)
		// gl.glOrtho(-4.0, 4.0, -4.0*height/width,
		// 4.0*height/width, -4.0, 4.0);
		// else
		// gl.glOrtho(-4.0*width/height,
		// 4.0*width/height, -4.0, 4.0, -4.0, 4.0);
		// gl.glMatrixMode(GL.GL_MODELVIEW);
		// gl.glLoadIdentity();

		gl.glViewport(0, 0, width, height);
		if (height == 0)
			height = 1;
		viewportX = width;
		viewportY = height;
		xMax = (double) width / 2D;
		yMax = (double) height / 2D;
		double aspecto = xMax / yMax;
		// gl.glMatrixMode(GL.GL_PROJECTION);
		// gl.glLoadIdentity();
		if (aspecto > aspect) {
			xMax = X * (aspecto / aspect);
			yMax = Y;
			// glu.gluOrtho2D(-X * (aspecto / aspect), X * (aspecto / aspect),
			// -Y, Y);
		} else if (aspecto < aspect) {
			xMax = X;
			yMax = Y / aspecto * aspect;
			// glu.gluOrtho2D(-X, X, -Y / aspecto * aspect, Y / aspecto *
			// aspect);
		} else {
			xMax = X;
			yMax = Y;
			// glu.gluOrtho2D(-X, X, -Y, Y);
		}

		// gl.glViewport(0, 0, width, height);
		// gl.glMatrixMode(GL.GL_PROJECTION);
		// gl.glLoadIdentity();
		// if (width <= height){
		// xMax=700.0;
		// yMax=500.0*height/width;
		// // gl.glOrtho(-4.0, 4.0, -4.0*height/width,
		// // 4.0*height/width, -4.0, 4.0);
		// }else{
		// xMax=500.0*width/height;
		// yMax=500.0;
		// // gl.glOrtho(-4.0*width/height,
		// // 4.0*width/height, -4.0, 4.0, -4.0, 4.0);
		// }
		// gl.glMatrixMode(GL.GL_MODELVIEW);
		// gl.glLoadIdentity();

	}

	@Override
	public void keyPressed(KeyEvent e) {
		if (e.getKeyChar() == '-') {
			if (ortogonal.isSelected()) {

			} else if (axonometrica.isSelected()) {
				if (teta.isSelected()) {
					pteta -= 1;
				} else {
					pfi -= 1;
				}
				System.out.println("FI: " + pfi);
				System.out.println("Teta: " + pteta);
			} else if (obliqua.isSelected()) {
				if (teta.isSelected()) {
					if (l > 0.1)
						l -= 0.1;
				} else {
					Alfa -= 1;
				}
				System.out.println("Alfa: " + Alfa);
				System.out.println("L: " + l);
			} else if (perspectiva.isSelected()) {
				if (D > 150)
					D -= 1;
				System.out.println("D: " + D);
			}
		}
		if (e.getKeyChar() == '+') {
			if (ortogonal.isSelected()) {

			} else if (axonometrica.isSelected()) {
				if (teta.isSelected()) {
					pteta += 1;
				} else {
					pfi += 1;
				}
				System.out.println("FI: " + pfi);
				System.out.println("Teta: " + pteta);
			} else if (obliqua.isSelected()) {
				if (teta.isSelected()) {
					if (l < 0.9)
						l += 0.1;
				} else {
					Alfa += 1;
				}
				System.out.println("Alfa: " + Alfa);
				System.out.println("L: " + l);
			} else if (perspectiva.isSelected()) {
				D += 1;
				System.out.println("D: " + D);
			}
		}
		glDraw.display();
	}

	@Override
	public void keyReleased(KeyEvent e) {

	}

	@Override
	public void keyTyped(KeyEvent e) {

	}

}